//+==================================================================+
//|                                                  Volcano.mq4 |
//|                             Copyright  2008,   Nikolay Kositsin | 
//|                                     Stells, stells@seti.net.net  | 
//+==================================================================+
#property copyright "Copyright  2008, Nikolay Kositsin+Stells"
#property link "stells@seti.net.net"
//----+ +-----------------------------------------------------------------------+
//----     BUY 
extern int MAperiod_Up1 = 18;             //    .       
extern bool   Test_Up1 = true;//   
extern int    Timeframe_Up1 = 1440;
extern int    MAShift_Up1 = 0;
extern int    IPC_Up1 = 0;/*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
//----+ +-----------------------------------------------------------------------+
//----     SELL  
extern int MAperiod_Dn1 = 27;             //    .      
extern bool   Test_Dn1 = true;//   
extern int    Timeframe_Dn1 = 1440;
extern int    MAShift_Dn1 = 0;
extern int    IPC_Dn1 = 0;/*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
//----+ +-----------------------------------------------------------------------+
//----     BUY  
extern int MAperiod_Up2 = 5;             //    .      
extern bool   Test_Up2 = true;//   
extern int    Timeframe_Up2 = 240;
extern int    MAShift_Up2 = 0;
extern int    IPC_Up2 = 0;/*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
//----+ +-----------------------------------------------------------------------+
//----     SELL 
extern int MAperiod_Dn2 = 18;             //    .       
extern bool   Test_Dn2 = true;//   
extern int    Timeframe_Dn2 = 240;
extern int    MAShift_Dn2 = 0;
extern int    IPC_Dn2 = 0;/*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
//----+ +-----------------------------------------------------------------------+
//----     BUY 
extern int MAperiod_Up3 = 93;             //    .       
extern bool   Test_Up3 = true;//   
extern int    Timeframe_Up3 = 60;
extern int    MAShift_Up3 = 0;
extern double Money_Management_Up3 = 0.1;
extern int    IPC_Up3 = 0;/*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
extern int    STOPLOSS_Up3 = 70;  // 
extern int    TAKEPROFIT_Up3 = 92; // 
extern bool   ClosePos_Up3 = true; //    
//----+ +-----------------------------------------------------------------------+
//----     SELL 
extern int MAperiod_Dn3 = 86;             //    .       
extern bool   Test_Dn3 = true;//   
extern int    Timeframe_Dn3 = 60;
extern int    MAShift_Dn3 = 0;
extern double Money_Management_Dn3 = 0.1;
extern int    IPC_Dn3 = 0;/*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
extern int   STOPLOSS_Dn3 = 34;  // 
extern int   TAKEPROFIT_Dn3 = 84; // 
extern bool   ClosePos_Dn3 = true; //    
//----+ +-----------------------------------------------------------------------+

//----      
int MinBar_Up1, MinBar_Up2, MinBar_Up3;
int MinBar_Dn1, MinBar_Dn2, MinBar_Dn3;
//+==================================================================+
//| Custom Expert functions                                          |
//+==================================================================+

//+==================================================================+
//| TimeframeCheck() functions                                       |
//+==================================================================+
void TimeframeCheck(string Name, int Timeframe)
  {
//----+
   //----    Timeframe  
   if (Timeframe != 1)
    if (Timeframe != 5)
     if (Timeframe != 15)
      if (Timeframe != 30)
       if (Timeframe != 60)
        if (Timeframe != 240)
         if (Timeframe != 1440)
           Print(StringConcatenate(" ",Name,
                     "   ", "  ", Timeframe, "!!!"));    
//----+ 
  }
//+==================================================================+
//| Custom Expert initialization function                            |
//+==================================================================+
int init()
  {
//----       
   TimeframeCheck("Timeframe_Up1", Timeframe_Up1);
   TimeframeCheck("Timeframe_Up2", Timeframe_Up2);
   TimeframeCheck("Timeframe_Up3", Timeframe_Up3);

//----        
   TimeframeCheck("Timeframe_Dn1", Timeframe_Dn1); 
   TimeframeCheck("Timeframe_Dn2", Timeframe_Dn2); 
   TimeframeCheck("Timeframe_Dn3", Timeframe_Dn3);
   
//----               
   MinBar_Up1 = 500;
   MinBar_Up2 = 500;
   MinBar_Up3 = 500;
   
   MinBar_Dn1 = 500;
   MinBar_Dn2 = 500;  
   MinBar_Dn3 = 500;                                          
//----  
   return(0);
  }
//+==================================================================+
//| expert deinitialization function                                 |
//+==================================================================+  
int deinit()
  {
//----+
   
    //----   
    return(0);
//----+ 
  }
//+==================================================================+
//| Custom Expert iteration function                                 |
//+==================================================================+
int start()
  {
   //----+   
   int    bar;
   double Mov[3], dMov12, dMov23;
   //----+   
   static int LastBars_Up1, LastBars_Dn1;
   static int LastBars_Up2, LastBars_Dn2;
   static int LastBars_Up3, LastBars_Dn3;
   
   static bool BUY_Sign_1, BUY_Stop1, SELL_Sign_1, SELL_Stop1;
   static bool BUY_Sign_2, BUY_Stop2, SELL_Sign_2, SELL_Stop2;
   static bool BUY_Sign3, BUY_Stop3, SELL_Sign3, SELL_Stop3;
   
   //+------------------------------------------------------------------------+
   
   //----++    
   if (Test_Up1) 
    {
      int IBARS_Up1 = iBars(NULL, Timeframe_Up1);
      
      if (IBARS_Up1 >= MinBar_Up1)
       {
         if (LastBars_Up1 != IBARS_Up1)
          {
           //----+   
           BUY_Sign_1 = 0;
           LastBars_Up1 = IBARS_Up1; 
           
           //----+                
           for(bar = 1; bar <= 3; bar++)
                     Mov[bar - 1]=                  
                         iMA(NULL, Timeframe_Up1, MAperiod_Up1, MODE_EMA, IPC_Up1, MAShift_Up1, bar);
           
           //----+     
           dMov12 = Mov[0] - Mov[1];
           dMov23 = Mov[1] - Mov[2]; 
                                          
           if (dMov23 < 0)
              if (dMov12 > 0)
                        BUY_Sign_1 = 1;
//                      else BUY_Sign_1 = 0;                   
          }

        }
     }
     
   //----++    
   if (Test_Dn1) 
    {
      int IBARS_Dn1 = iBars(NULL, Timeframe_Dn1);
      
      if (IBARS_Dn1 >= MinBar_Dn1)
       {
         if (LastBars_Dn1 != IBARS_Dn1)
          {
           //----+   
           SELL_Sign_1 = 0;
           LastBars_Dn1 = IBARS_Dn1; 
           
           //----+                
           for(bar = 1; bar <= 3; bar++)
                     Mov[bar - 1]=                  
                         iMA(NULL, Timeframe_Dn1, MAperiod_Dn1, MODE_EMA, IPC_Up1, MAShift_Dn1, bar);
           
           //----+    
           dMov12 = Mov[0] - Mov[1];
           dMov23 = Mov[1] - Mov[2]; 
                                           
           if (dMov23 > 0)
              if (dMov12 < 0)
                       SELL_Sign_1 = 1;
//                       else SELL_Sign_1 = 0;   
                                        
          }

        }
     }
    //+------------------------------------------------------------------------+
    //----++    
   if (Test_Up2) 
    {
      int IBARS_Up2 = iBars(NULL, Timeframe_Up2);
      
      if (IBARS_Up2 >= MinBar_Up2)
       {
         if (LastBars_Up2 != IBARS_Up2)
          {
           //----+   
          BUY_Sign_2 = 0;
           LastBars_Up2 = IBARS_Up2; 
           
           //----+                
           for(bar = 1; bar <= 3; bar++)
                     Mov[bar - 1]=                  
                         iMA(NULL, Timeframe_Up2, MAperiod_Up2, MODE_EMA, IPC_Up2, MAShift_Up2, bar);
           
           //----+     
           dMov12 = Mov[0] - Mov[1];
           dMov23 = Mov[1] - Mov[2]; 
                                          
           if (dMov23 < 0)
              if (dMov12 > 0)
                        BUY_Sign_2 = 1;
//                       else BUY_Sign_2 = 0;   
                                     
          }


        }
     }
     
   //----++    
   if (Test_Dn2) 
    {
      int IBARS_Dn2 = iBars(NULL, Timeframe_Dn2);
      
      if (IBARS_Dn2 >= MinBar_Dn2)
       {
         if (LastBars_Dn2 != IBARS_Dn2)
          {
           //----+   
           SELL_Sign_2 = 0;
           LastBars_Dn2 = IBARS_Dn2; 
           
           //----+                
           for(bar = 1; bar <= 3; bar++)
                     Mov[bar - 1]=                  
                         iMA(NULL, Timeframe_Dn2, MAperiod_Dn2, MODE_EMA, IPC_Dn2, MAShift_Dn2, bar);
           
           //----+    
           dMov12 = Mov[0] - Mov[1];
           dMov23 = Mov[1] - Mov[2]; 
                                           
           if (dMov23 > 0)
              if (dMov12 < 0)
                       SELL_Sign_2 = 1;
//                     else SELL_Sign_2 = 0;                  
          }

        }
     }
    //+------------------------------------------------------------------------+
    //----++    
   if (Test_Up3) 
    {
      int IBARS_Up3 = iBars(NULL, Timeframe_Up3);
      
      if (IBARS_Up3 >= MinBar_Up3)
       {
         if (LastBars_Up3 != IBARS_Up3)
          {
           //----+   
           BUY_Sign3 = false;
           BUY_Stop3 = false;
           LastBars_Up3 = IBARS_Up3; 
           
           //----+                
           for(bar = 1; bar <= 3; bar++)
                     Mov[bar - 1]=                  
                         iMA(NULL, Timeframe_Up3, MAperiod_Up3, MODE_EMA, IPC_Up3, MAShift_Up3, bar);
           
           //----+     
           dMov12 = Mov[0] - Mov[1];
           dMov23 = Mov[1] - Mov[2]; 
                                          
           if (dMov23 < 0)
              if (dMov12 > 0)
//                 if (BUY_Sign_1==1 && BUY_Sign_2==1)
                  if (BUY_Sign_1==1)
                        BUY_Sign3 = true;
                          
           if (dMov12 < 0)
                        BUY_Stop3 = true;                                           
          }
          //----+  
          if (!OpenBuyOrder_Ch(BUY_Sign3, 1, Money_Management_Up3, 
                                          STOPLOSS_Up3, TAKEPROFIT_Up3))
                                                                 return(-1);
          if (ClosePos_Up3)
                if (!CloseOrder_Ch(BUY_Stop3, 1))
                                          return(-1);
        }
     }
     
   //----++    
   if (Test_Dn3) 
    {
      int IBARS_Dn3 = iBars(NULL, Timeframe_Dn3);
      
      if (IBARS_Dn3 >= MinBar_Dn3)
       {
         if (LastBars_Dn3 != IBARS_Dn3)
          {
           //----+   
           SELL_Sign3 = false;
           SELL_Stop3 = false;
           LastBars_Dn3 = IBARS_Dn3; 
           
           //----+                
           for(bar = 1; bar <= 3; bar++)
                     Mov[bar - 1]=                  
                         iMA(NULL, Timeframe_Dn3, MAperiod_Dn3, MODE_EMA, IPC_Dn3, MAShift_Dn3, bar);
                                                         
           //----+    
           dMov12 = Mov[0] - Mov[1];
           dMov23 = Mov[1] - Mov[2]; 
                                           
           if (dMov23 > 0)
              if (dMov12 < 0)
 //                if (SELL_Sign_1 == 1 && SELL_Sign_2==1)
               if (SELL_Sign_1 == 1)
                       SELL_Sign3 = true;
                          
           if (dMov12 > 0)
                       SELL_Stop3 = true;                                           
          }
          //----+  
          if (!OpenSellOrder_Ch(SELL_Sign3, 2, Money_Management_Dn3, 
                                            STOPLOSS_Dn3, TAKEPROFIT_Dn3))
                                                                   return(-1);
          if (ClosePos_Dn3)
                if (!CloseOrder_Ch(SELL_Stop3, 2))
                                          return(-1);
        }
     }
    //+------------------------------------------------------------------------+
//----+ 
    
    return(0);
  }
//Championship 2008 Version  July 01, 2008
//+==================================================================+
//|                                            Lite_EXPERT_Champ.mqh |
//|                             Copyright  2008,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+==================================================================+
//----      
                            //    
int LastTime; 
//+==================================================================+
//| OpenBuyOrder_Ch()                                                |
//+==================================================================+
bool OpenBuyOrder_Ch
        (bool& BUY_Signal, int MagicNumber, 
                double Money_Management, int STOPLOSS, int TAKEPROFIT)
 {
//----+
  if (!BUY_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  int total = OrdersTotal();
  
  //----        
  if (total > 2)
            return(true); 
            
   //----      
          //      MagicNumber
  for(int ttt = total - 1; ttt >= 0; ttt--)     
      if (OrderSelect(ttt, SELECT_BY_POS, MODE_TRADES))
                      if (OrderMagicNumber() == MagicNumber)
                                                      return(true);

/*
  int unt1;                                                    
  //----      
          //      MagicNumber
  for(int ttt = total - 1; ttt >= 0; ttt--)
       if (OrderSelect(ttt, SELECT_BY_POS, MODE_TRADES))
                      if (OrderMagicNumber() == MagicNumber)
                          if(OrderType() == OP_BUY)
                                                        unt1++; 
     
  //----      
          //      MagicNumber
  if (unt1 > 2)
         return(true);                                                      
*/                                                       
  string OpderPrice, Symb = Symbol(); 
  int    ticket, StLOSS, TkPROFIT;
  double LOTSTEP, MINLOT, MAXLOT, MARGINREQUIRED;
  double FreeMargin, LotVel, Lot, ask, Stoploss, TakeProfit; 
  
  //----    
  LOTSTEP = 0.1;
  MINLOT = 0.1;
  MAXLOT = 5;                                               
                                                      
  //----+      
  if (Money_Management > 0)
    {        
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)
                    return(false);
                    
      LotVel = GetFreeMargin()
               * Money_Management / MARGINREQUIRED;         
    }
  else 
    LotVel = MathAbs(Money_Management);
  
  //----        
  Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);  
  
  //----+      
  if (Lot < MINLOT)
          return(true);
          
  //----+      
  if (Lot > MAXLOT)
          Lot = MAXLOT;
          
  //----+           
  if (!MarginCheck_Ch(Symb, OP_BUY, Lot))
                               return(false);
  if (Lot < MINLOT)
          return(true);
  //----
  ask = NormalizeDouble(Ask, Digits);
  if (ask == 0.0)
          return(false);
  //----             
  StLOSS = StopCorrect(Symb, STOPLOSS, 3);
  if (StLOSS < 0)
          return(false);   
  //----
  Stoploss = NormalizeDouble(ask - StLOSS * Point, Digits);
  if (Stoploss < 0)
         return(false);
  //----       
  TkPROFIT = TakeProfitCorrect(Symb, TAKEPROFIT, 3);
  if (TkPROFIT < 0)
          return(false);  
  //----               
  TakeProfit = NormalizeDouble(ask + TkPROFIT * Point, Digits);
  if (TakeProfit < 0)
         return(false);
  
  Print(StringConcatenate
         ("  ", Symb,
            "       ", MagicNumber));
            
  //----+        
  ticket = OrderSend(Symb, OP_BUY, Lot, ask, 3, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Lime);
  
  //----               
  CountLastTime(GetLastError());
  //----
  if(ticket > 0)
   {
     if (OrderSelect(ticket, SELECT_BY_TICKET))
       {
         BUY_Signal = false;
         OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
         Print(StringConcatenate(Symb, " BUY    ",
                ticket, "    ", OrderMagicNumber(), 
                                         "    ",OpderPrice));
         return(true);
       }
     else
       {
         Print(StringConcatenate("   ", Symb, 
            " BUY     ", MagicNumber, "!!!"));
         return(true);
       }
    }
  else
    {
      Print(StringConcatenate("   ", Symb, 
           " BUY     ", MagicNumber, "!!!"));
      return(true);
    }
  //---- 
  return(true);
//----+
 }
//+==================================================================+
//| OpenSellOrder_Ch()                                               |
//+==================================================================+
bool OpenSellOrder_Ch
        (bool& SELL_Signal, int MagicNumber, 
                double Money_Management, int STOPLOSS, int TAKEPROFIT)
 {
//----+
  if (!SELL_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  int total = OrdersTotal();
  
  //----        
  if (total > 2)
            return(true); 
            
 //----      
          //      MagicNumber
  for(int ttt = total - 1; ttt >= 0; ttt--)     
      if (OrderSelect(ttt, SELECT_BY_POS, MODE_TRADES))
                      if (OrderMagicNumber() == MagicNumber)
                                                      return(true);

/* 
  int unt2;                                                    
  //----      
          //      MagicNumber
  for(int ttt = total - 1; ttt >= 0; ttt--) 
       if (OrderSelect(ttt, SELECT_BY_POS, MODE_TRADES))
                      if (OrderMagicNumber() == MagicNumber)
                           if(OrderType() == OP_SELL) 
                                                        unt2++; 
     
  //----      
          //      MagicNumber
  if (unt2 > 2)
         return(true);
*/                                                        
  string OpderPrice, Symb = Symbol(); 
  int    SPREAD, ticket, StLOSS, TkPROFIT;
  double LOTSTEP, MINLOT, MAXLOT, MARGINREQUIRED, TICKSIZE;
  double LotVel, Lot, bid, Stoploss, TakeProfit, TICKVALUE;
  
  //----    
  LOTSTEP = 0.1;
  MINLOT = 0.1;
  MAXLOT = 5;                                                 
                                                      
  //----+      
  if (Money_Management > 0)
    {        
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)
                    return(false);
      //---
      SPREAD = MarketInfo(Symb, MODE_SPREAD);
      //---
      TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
      //---
      LotVel = GetFreeMargin() * Money_Management / 
                    (MARGINREQUIRED - (SPREAD * TICKVALUE));                  
    }
  else 
    LotVel = MathAbs(Money_Management);

  //----          
  Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);
  
  //----+      
  if (Lot < MINLOT)
          return(true);
          
  //----+      
  if (Lot > MAXLOT)
          Lot = MAXLOT;
          
  //----+           
  if (!MarginCheck_Ch(Symb, OP_SELL, Lot))
                                  return(false);
  if (Lot < MINLOT)
          return(true);
  //----
  bid = NormalizeDouble(Bid, Digits);
  if (bid == 0.0)
          return(false);
  //----             
  StLOSS = StopCorrect(Symb, STOPLOSS, 3);
  if (StLOSS < 0)
          return(false);   
  //----
  Stoploss = NormalizeDouble(bid + StLOSS * Point, Digits);
  if (Stoploss < 0)
         return(false);
  //----       
  TkPROFIT = TakeProfitCorrect(Symb, TAKEPROFIT, 3);
  if (TkPROFIT < 0)
          return(false);  
  //----      
  TakeProfit = NormalizeDouble(bid - TkPROFIT * Point, Digits);
  if (TakeProfit < 0)
         return(false);
  //---- 
  Print(StringConcatenate
         ("  ", Symb,
               "       ", MagicNumber)); 
                  
  //----+        
  ticket = OrderSend(Symb, OP_SELL, Lot, bid, 3, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Red);
              
  //----              
  CountLastTime(GetLastError());
  //----
  if(ticket > 0)
   {
     if (OrderSelect(ticket, SELECT_BY_TICKET))
       {
         SELL_Signal = false;
         OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
         Print(StringConcatenate(Symb, " SELL    ",
                 ticket, "    ", OrderMagicNumber(), 
                                            "    ",OpderPrice));
         return(true);
       }
     else
       {
         Print(StringConcatenate("   ", Symb, 
              " SELL     ", MagicNumber, "!!!"));
         return(true);
       }
    }
   else
    {
      Print(StringConcatenate("   ", Symb, 
              " SELL     ", MagicNumber, "!!!"));
      return(true);
    }
  //----  
  return(true);
//----+  
 }   
//+==================================================================+
//| GetFreeMargin() function                                         |
//+==================================================================+
double GetFreeMargin()
  {
//----+
   switch(AccountFreeMarginMode())
       {
        
        case 0: return(AccountFreeMargin() + AccountProfit());
        case 1: return(AccountFreeMargin());
        case 2: if (AccountProfit() > 0) 
                  return(AccountFreeMargin());
                else
                  return(AccountFreeMargin() - AccountProfit());
        case 3: if (AccountProfit() < 0) 
                  return(AccountFreeMargin());
                else
                  return(AccountFreeMargin() - AccountProfit());
       }
//----+
  } 
//+==================================================================+
//| StopCorrect() function                                           |
//+==================================================================+
int StopCorrect(string symbol, int Stop, int slippage)
  {
//----+
   int CorrStop, Extrem_Stop;
   //---
   Extrem_Stop = MarketInfo(symbol, MODE_STOPLEVEL) + slippage;
   //---             
   if(Stop < Extrem_Stop)
               CorrStop = Extrem_Stop;
   else 
      CorrStop = Stop;
   //---   
   return(CorrStop);
//----+
  }
//+==================================================================+
//| TakeProfitCorrect() function                                     |
//+==================================================================+
int TakeProfitCorrect(string symbol, int TakeProfit, int slippage)
  {
//----+
   int CorrStop, Extrem_Stop, SPREAD, PipsLevel;
   //---
   Extrem_Stop = MarketInfo(symbol, MODE_STOPLEVEL);
   SPREAD = MarketInfo(symbol, MODE_SPREAD);
   
   //---     !!!
   PipsLevel = SPREAD + slippage + 3;
   if(Extrem_Stop < PipsLevel)
            Extrem_Stop = PipsLevel;
   //---             
   if(TakeProfit < Extrem_Stop)
               CorrStop = Extrem_Stop;
   else 
      CorrStop = TakeProfit;
   //---   
   return(CorrStop);
//----+
  }  
//+==================================================================+
//| MarginCheck_Ch() function                                        |
//+==================================================================+ 
bool MarginCheck_Ch(string symbol, int Cmd, double& Lot) 
 {
//----+
   int  Margin_Check;
   //---
   double MINLOT = 0.1;
   //---           
   double LOTSTEP = 0.1;
   //---           
   Lot = LOTSTEP * MathFloor(Lot / LOTSTEP); 
   //---
   while(Lot >= MINLOT && Margin_Check <= 0)
     {
       Margin_Check =
         AccountFreeMarginCheck(symbol, Cmd, Lot);
       //---              
       if (Margin_Check < 0)
                     Lot -= LOTSTEP; 
       //---              
       if (Lot < MINLOT)
                   return(true);
     }
            
  return(true);
//----+
 }
//+==================================================================+
//| CountLastTime() function                                         |
//+==================================================================+
void CountLastTime(int Error)
  {
//----+
   int TimeCurr = TimeCurrent();
   //---
   switch(Error)
       {
        case 000: LastTime = TimeCurr + 000; break;
        case 001: LastTime = TimeCurr + 060; break;
        case 002: LastTime = TimeCurr + 300; break;
        case 003: LastTime = TimeCurr + 300; break;                                                                  
        case 004: LastTime = TimeCurr + 180; break; 
        case 005: LastTime = TimeCurr + 000; break;
        case 006: LastTime = TimeCurr + 006; break;
        case 008: LastTime = TimeCurr + 011; break;
        case 064: LastTime = TimeCurr + 300; break;
        case 065: LastTime = TimeCurr + 180; break;                                                     
        case 128: LastTime = TimeCurr + 065; break; 
        case 129: LastTime = TimeCurr + 006; break; 
        case 130: LastTime = TimeCurr + 006; break;  
        case 131: LastTime = TimeCurr + 300; break;
        case 132: LastTime = TimeCurr + 180; break;
        case 133: LastTime = TimeCurr + 300; break;
        case 134: LastTime = TimeCurr + 006; break; 
        case 135: LastTime = TimeCurr + 000; break;
        case 136: LastTime = TimeCurr + 006; break; 
        case 138: LastTime = TimeCurr + 000; break;
        case 139: LastTime = TimeCurr + 011; break;
        case 140: LastTime = TimeCurr + 011; break; 
        case 141: LastTime = TimeCurr + 011; break;
        case 142: LastTime = TimeCurr + 065; break; 
        case 143: LastTime = TimeCurr + 065; break; 
        case 144: LastTime = TimeCurr + 011; break; 
        case 145: LastTime = TimeCurr + 016; break;  
        case 146: LastTime = TimeCurr + 300; break;
        case 147: LastTime = TimeCurr + 011; break;
        case 148: LastTime = TimeCurr + 300; break;
        default:  LastTime = TimeCurr + 000; break;
       }
//----+
  } 
//+==================================================================+
//| CloseOrder_Ch() function                                         |
//+==================================================================+

bool CloseOrder_Ch(bool& CloseStop, int MagicNumber)
  {
//----+
   if (!CloseStop)
          return(true);
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
   if (total == 0)
              return(true);
   //----
   color  Order_Color;
   string ClosePrice, Symb, Order_Type;
   double priceClose;
   int    ticket, DIGITS, FREEZELEVEL; 
   int    FreezeLevelT, FreezeLevelS, PointProfit;
   
   //----       
   for(int pos=total-1;pos>=0;pos--)                                                                 
     {
      if (OrderSelect(pos, SELECT_BY_POS))
         if (OrderMagicNumber() == MagicNumber)
                                if (OrderType() < 2)
                                                 break;
      if (pos == 0)
               return(true);
     }
   //---- 
   ticket = OrderTicket(); 
   Symb = OrderSymbol();
   //---- 
   DIGITS = MarketInfo(OrderSymbol(), MODE_DIGITS); 
   if (DIGITS == 0)
             return(false);
                
   //----+     
   switch(OrderType())
     {
      
      case OP_BUY:
       {
         priceClose = MarketInfo(Symb, MODE_BID);
         if (priceClose == 0)
                    return(false);
                    
         PointProfit = (priceClose - OrderOpenPrice()) / Point;
         Order_Type =" BUY";
         Order_Color = Red;
         break;
       }
      //----   
      case OP_SELL:
       {
         priceClose = MarketInfo(Symb, MODE_ASK);
         if (priceClose == 0)
                    return(false);
                    
         PointProfit = (OrderOpenPrice() - priceClose) / Point;
         Order_Type =" SELL";
         Order_Color = Lime;
         break;
       }
      default : 
         return(true);
     }
   //----+      
   if (PointProfit >= 0)
     if (PointProfit < TakeProfitCorrect(Symb, PointProfit, 0))
                                                       return(true);
   //----+     
   FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
   FreezeLevelT = MathAbs(priceClose - OrderTakeProfit()) / Point;
   FreezeLevelS = MathAbs(priceClose - OrderStopLoss()) / Point;
   //----
   if (FreezeLevelT <= FREEZELEVEL)
                               return(true);
   if (FreezeLevelS <= FREEZELEVEL)
                               return(true);
   
   //----+                                     
   Print(StringConcatenate("  ", pos,
        "  ", Symb, Order_Type, "    ", ticket,
                                   "    ", MagicNumber));
   //----                                          
   if(OrderClose(ticket, OrderLots(), priceClose, 3, Order_Color))
     {
       CloseStop = false;
       ClosePrice = DoubleToStr(OrderClosePrice(), DIGITS);  
       Print(StringConcatenate(Symb, Order_Type, "    ",
                       ticket, "    ", OrderMagicNumber(), 
                                             "    ", ClosePrice));
       //----              
       CountLastTime(GetLastError());
       //----
       return(true);
     }
   else 
     {
       Print(StringConcatenate("   ", Symb, 
          Order_Type,"    ", ticket, "    ", 
                                                         MagicNumber, "!!!"));
       //----             
       CountLastTime(GetLastError());
       //----
       return(true);
     }
    //----   
   return(true);
//----+
  }       

